# Syscalls
.equ SYSCALL_EXIT,     1
.equ SYSCALL_READ,     3
.equ SYSCALL_WRITE,    4
.equ SYSCALL_OPEN,     5
.equ SYSCALL_CLOSE,    6

# From /usr/include/asm-generic/fcntl.h
.equ O_RDONLY,         0
.equ O_WRONLY,         1
.equ O_CREAT,   00000100

        .globl _start
_start:

#
# Open the file
#

#   fd=open("input.bin",O_RDONLY);

	mov	$filename,%ebx			# filename
	mov	$O_RDONLY,%ecx		# flags
	mov	$SYSCALL_OPEN,%eax
	int	$0x80

        push    %eax                    # save for later
   
        mov     %eax,%ebx

#   read(fd,&xsize,4);
        mov     $SYSCALL_READ,%eax
	mov     $xsize,%ecx
	mov     $4,%edx
	int     $0x80

#   read(fd,&ysize,4);   
        mov     $SYSCALL_READ,%eax
	mov     $ysize,%ecx
	mov     $4,%edx
	int     $0x80	
   
#   read(fd,datain,xsize*ysize*sizeof(int));
   
        mov     $SYSCALL_READ,%eax
	mov     $inbuff,%ecx
	mov     $(320*320*4),%edx
	int     $0x80	   

#   close(fd);

       pop      %ebx                    # mov fd into %ebx
       mov      $SYSCALL_CLOSE,%eax
       int      $0x80
   
#   /* Data all read in */
   
#   dataout=malloc(xsize*ysize*sizeof(int));   
#   {
		
#   int emboss_filter[3][3]={{0,0,0},{0,1,0},{0,0,-1}};
#   int x,y,k,l,r,g,b;
#   unsigned int color;
#   int sumr,sumg,sumb;

#define RSHIFT 24
#define GSHIFT 16
#define BSHIFT 8

       mov $(321),%esi

       mov $(321),%edi


       mov $318,%ebx
outer_loop:
       mov $318,%ecx
	
inner_loop:
	mov inbuff(,%esi,4),%eax
        mov (inbuff+(321*4))(,%esi,4),%ebp
        inc %esi

	xor %edx,%edx

blue:		
	push %eax
	push %ebp

	shr  $8,%eax
	and  $0xff,%eax

	shr  $8,%ebp
	and  $0xff,%ebp

	neg  %ebp
	add  %ebp,%eax

	and  $0xff,%eax
	
	mov  %al,%dl
	ror  $8,%edx
	
	pop  %ebp
	pop  %eax

	
green:
	push %eax
	push %ebp
	
	shr  $16,%eax
	and  $0xff,%eax

	shr  $16,%ebp
	and  $0xff,%ebp

	neg  %ebp
	add  %ebp,%eax

	and  $0xff,%eax
	
	mov  %al,%dl
	ror  $8,%edx
	
	pop  %ebp
	pop  %eax	

red:
	push %eax
	push %ebp
	
	shr  $24,%eax
	and  $0xff,%eax

	shr  $24,%ebp
	and  $0xff,%ebp

	neg  %ebp
	add  %ebp,%eax

	and  $0xff,%eax
	
	mov  %al,%dl
	ror  $8,%edx
	
	pop  %ebp
	pop  %eax
	
	
	
done_color:
	
	mov %edx,outbuff(,%edi,4)
	inc %edi
	
#       loop inner_loop
	dec %ecx
	jnz inner_loop
	
       add $2,%esi
       add $2,%edi
       dec %ebx
       jnz outer_loop

	
	
#   for(x=1;x<xsize-1;x++) {
#      for(y=1;y<ysize-1;y++) {
		       
#	 sumr=0; sumb=0; sumg=0;
		       
#	 for(k=-1;k<2;k++) {
#	    for(l=-1;l<2;l++) {
#	       color=datain[((y+l)*xsize)+(x+k)];
#	       r=(color>>RSHIFT)&0xff;
#	       g=(color>>GSHIFT)&0xff;
#	       b=(color>>BSHIFT)&0xff;
#	       sumr+=r*emboss_filter[k+1][l+1];
#	       sumg+=g*emboss_filter[k+1][l+1];
#	       sumb+=b*emboss_filter[k+1][l+1];
#	    }
#	 }
		       
#	 color=((sumr&0xff)<<RSHIFT)+((sumg&0xff)<<GSHIFT)+
#	       ((sumb&0xff)<<BSHIFT);
#	 dataout[(y*xsize)+x]=color;
#     }
#   }
#   }
      
      
   
   
   
#   /* Done manipulating */
   
#   fd=open("output.bin",O_WRONLY|O_CREAT,0660);

	mov	$outfilename,%ebx			# filename
	mov	$(O_WRONLY|O_CREAT),%ecx		# flags
        mov     $0660,%edx
        mov	$SYSCALL_OPEN,%eax
	int	$0x80

        push    %eax                    # save for later
   
        mov     %eax,%ebx
   
#   write(fd,&xsize,sizeof(int));
        mov     $SYSCALL_WRITE,%eax
	mov     $xsize,%ecx
	mov     $4,%edx
	int     $0x80

#   write(fd,&ysize,sizeof(int));
        mov     $SYSCALL_WRITE,%eax
	mov     $ysize,%ecx
	mov     $4,%edx
	int     $0x80
	
#   write(fd,dataout,xsize*ysize*sizeof(int));
        mov     $SYSCALL_WRITE,%eax
	mov     $outbuff,%ecx
	mov     $(320*320*4),%edx
	int     $0x80
	
#   close(fd);

       pop      %ebx                    # mov fd into %ebx
       mov      $SYSCALL_CLOSE,%eax
       int      $0x80

#   return 0;
#}





        #================================
        # Exit
        #================================
exit:
	mov	$5,%ebx
        mov     $SYSCALL_EXIT,%eax       # put exit syscall number (1) in eax
        int     $0x80                   # and exit


.data
hello:		.ascii "Hello World!\n"
filename:       .string "input.bin"
outfilename:    .string "output.bin"

.bss
.lcomm          xsize,4
.lcomm          ysize,4
.lcomm          inbuff,320*320*4
.lcomm          outbuff,320*320*4
